package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;
import java.util.HashMap;
import java.util.Map;



/**
 * @author leon on 10/12/2018.
 */
public class Student{
    private Map<Lab, LabStatus> map;

    public Student() {
        this.map = new HashMap<>();
    }

    public Student(Map<Lab, LabStatus> map) {
        this.map = map;

    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {
        if (map.containsKey(lab)){
            map.replace(lab, labStatus);
        }else{
            throw new UnsupportedOperationException("Method not yet implemented");
        }
    }


    public void forkLab(Lab lab) {
        map.put(lab,LabStatus.PENDING);

    }

    public LabStatus getLabStatus(String labName) {
        LabStatus ls = null;
        for (Lab lab : map.keySet()){
            if (lab.getName() == labName){
                ls =map.get(lab);
            }
        }

        return ls;
    }

    public String toString(){
        StringBuilder sb = new StringBuilder();
        for (Lab lab : map.keySet()){
            sb.append(lab.getName() + " > " + map.get(lab));
            sb.append("\n");
        }

      return sb.toString().trim();
    }
}
