package rocks.zipcode.io.quiz3.fundamentals;


import static rocks.zipcode.io.quiz3.fundamentals.VowelUtils.getIndexOfFirstVowel;
import static rocks.zipcode.io.quiz3.fundamentals.VowelUtils.isVowel;

/**
 * @author leon on 09/12/2018.
 */
public class PigLatinGenerator {
    public String translate(String str) {
        String pigLatin = null;
        char[] characters = str.toCharArray();
        if (isVowel(characters[0])){
            pigLatin = str+"way";
        }else if(!isVowel(characters[0])){
            Integer index = getIndexOfFirstVowel(str);
            if(index == null){
                pigLatin = str+"ay";
            }else if (index >= 0) {
                pigLatin = str.substring(index) + str.substring(0, index) + "ay";
            }
        }else if(!isAlpha(str)){
            pigLatin = null;
        }

        return pigLatin;
    }

    public boolean isAlpha(String name) {
        return name.matches("[a-zA-Z]+");
    }
}
