package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] columns = new String[board[0].length];
        for (int i = 0; i < board.length; i++){
            columns[i] = board[i][value];
        }
        return columns;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        boolean homogenous = false;
        for(int i = 0; i < board[0].length-1; i++){
            if(board[rowIndex][i] == board[rowIndex][i+1]){
                homogenous = true;
            }else{
                homogenous = false;
                break;
            }
        }

        return homogenous;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {

        boolean homogenous = false;
        for(int i = 0; i < board.length-1; i++){
            if(board[i][columnIndex] == board[i+1][columnIndex]){
                homogenous = true;
            }else{
                homogenous = false;
                break;
            }
        }

        return homogenous;
    }

    public boolean isDiagonal(Integer startingCorner){
        boolean isDiagonal = false;
            int j = 0;
            for (int i = 0; i < board.length; i++){
                    if(board[i][j] == board[i+1][j+1]){
                        isDiagonal = true;

                    }else{
                        isDiagonal = false;
                        break;
                    }
            }
            return isDiagonal;

    }

    public String getWinner() {
        String winner = null;
        for (int i = 0; i < board.length; i++){
            if(isRowHomogenous(i)){
                winner = board[i][i];
            }if(isColumnHomogeneous(i)){
                winner = board[i][i];
            }
        }

        return winner;
    }
}
